/* Test for quoted strings*/
#include "CifFileObj.h"
#include <iostream.h>


#define FALSE 0
int main() {
  char *diags=NULL;
  CifFileObj * fobjR = NULL;

  fobjR = new CifFileObj("./test/TESTFILE6", WRITE_MODE, 80, "?", 1);
  fobjR->Read("./test/Test1.cif",diags);
  if (diags) cout << " Diagnostics [" << strlen(diags) << "] " << diags << endl;

#if 0
  cerr << "PrintHeaderInfo() - After Read()" << endl;
  fobjR->PrintHeaderInfo();
  cerr << "+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" << endl;
  cerr << "PrintIndex() - After Read()" << endl;
  fobjR->PrintIndex();
#endif

  cout<<fobjR->GetNumBlocks()<<endl;

  fobjR->Write("./test/Test1.ocif");

#if 0
  cerr << "PrintHeaderInfo() - After Write" << endl;
  fobjR->PrintHeaderInfo();
  cerr << "+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" << endl;
  cerr << "PrintIndex() - After Write" << endl;
  fobjR->PrintIndex();
#endif

  fobjR->CloseFile(1);
  if (fobjR) delete fobjR;

  fobjR = new CifFileObj("./test/TESTFILE6", READ_MODE, 80, "?", 0);
  ISTable *sst=new ISTable();
  sst=fobjR->GetTablePtr("DATABLOCK_1","category0");
  sst->PrintTable();
  cout<<sst->GetNumColumns()<<endl;
  fobjR->CloseFile(0);
  if (fobjR) delete fobjR;
  exit(0);
}
