#include "CifFileObj.h"
#include <iostream.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>


#define FALSE 0
int main() {
  char *diags=NULL;
  CifFileObj * fobjR = NULL;

  fobjR = new CifFileObj("./test/TESTFILE7", WRITE_MODE, 80, "?", 0);
  fobjR->Read("./test/ADH041.cif",diags);
  cout<<"diags = ";
  if (diags != NULL)
  {
    cout<<diags;
  }
  cout<<endl;

  if (diags) cout << " Diagnostics [" << strlen(diags) << "] " << diags << endl;

  fobjR->DeleteTable("ADH041","atom_site");

  fobjR->CloseFile(1);
  if (fobjR) delete fobjR;
  fobjR = new CifFileObj("./test/TESTFILE7", READ_MODE, 80, "?", 1);
  fobjR->Write("./test/Test10.ocif",0);
  fobjR->CloseFile(0);
  if (fobjR) delete fobjR;
  exit(0);
}
