#!/bin/sh

# use extract to run everything in example_1.inp and get a mmcif file.
extract -ext input_data/log_script.inp

# use validation-v8 to validate the mmcif file.
validation-v8 -f script_example_1.cif -o 2 -public -exchange -adit

# use maxit-v8.01-O to reorder the mmcif format
maxit-v8.01-O -i script_example_1.cif -o 8 -exchange_in -exchange_out

# move the files to some directory and delete some log files. 
mv script_example_1.cif.cif script_example_1_deposit.cif
mv script_example_1.cif deposit/
mv script_example_1_deposit.cif deposit/
mv script_example_1_sf.cif deposit/
mv *.html  *.ps  *.letter   validation_result/
rm -f *log *err procheck* SEQUENCE.DAT *ERR validation.alignment

