
#include "DICFileObj.h"
#include "DDLFileObj.h"
#include <iostream.h>

#define FALSE 0
int main() {
  char *diags=NULL;
  DICFileObj * fobjR = NULL;
  ISTable *format;
  ISTable *ddlformat;
  DDLFileObj * ddl = NULL;

  ddl = new DDLFileObj((char*)"ddl", WRITE_MODE, 80, "?", 1);
  ddlformat = new ISTable("ddlformat");
  ddl->Read((char*)"./test/ddl-mm",ddlformat, diags);
  cout<<"diags = ";
  if (diags != NULL)
  {
    cout<<diags;
  }
  cout<<endl;


  format = new ISTable("format");
  fobjR = new DICFileObj((char*)"./test/TESTFILE6", WRITE_MODE, 80, "?", 0);

  fobjR->Read((char*)"./test/dictionary.dic",ddl , format, diags);

  cout<<"diags = ";
  if (diags != NULL)
  {
    cout<<diags;
  }
  cout<<endl;

  fobjR->Compress(ddl);
  fobjR->Write("./test/view2.ocif");
  fobjR->Write("./test/view2.dic",ddl,format);

  fobjR->CloseFile(1);
  if (fobjR) delete fobjR;
  exit(0);
}

