/* Test for selective reading*/
#include "CifFileObj.h"
#include <iostream.h>


int main() {
  CifFileObj * fobjR = NULL;
  char *diags=NULL;

  CifFileReadDef readDef;

  ReVarCifArray<CifString> catlist;
  catlist.Add("atom_site");
  readDef.SetCategoryList(catlist,D);

  ReVarCifArray<CifString> dblist;
  dblist.Add("ADH041");
  readDef.SetDataBlockList(dblist,A);

  fobjR = new CifFileObj("tmp", WRITE_MODE, 80, "?", 0);
  fobjR->Read("./test/ADH041.cif",diags,readDef);
  fobjR->Write("./test/test.cif");
  fobjR->CloseFile(0);
  
  if (fobjR) delete fobjR;
  exit(0);
}
